TextCritical.net - Bug #2869

Shortcut keys for next verse act weird
03/22/2021 03:04 AM - Luke Murphey

Status: Closed Start date: 03/21/2021
Priority: Normal Due date:
Assignee: Luke Murphey % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 4.6.7
Description
History
#1 - 01/06/2022 06:24 PM - Luke Murphey
Repro:

e Open work

¢ Press Shift+right several times; note that it moves several chapters

#2 - 01/07/2022 03:26 AM - Luke Murphey

Uncaught TypeError: Cannot read properties of null

#3 - 01/07/2022 05:40 AM - Luke Murphey
Questions:
e What is the related stack trace?

o readingMenuBar::upHandler()
Is the handler not getting removed properly?

(reading

Is the problem due to not having an empty array of dependencies after useEffect?

o https://www.pluralsight.com/guides/event-listeners-in-react-components

o This gets rid of the multiple addHandler() registrations but it also breaks it

When does useEffect()'s cleanup get called?

¢ Does this improve if | only add the handler if both goToNextChapter and goToPriorChapter are set?

o No change

¢ Does this work if | keep the handler around and only apply it if doesn't yet exist?

o No change
Observations:

e upHandler() is getting called several times

e addHandler() gets called 7 times on a normal load
o removeHandler() gets called 6 times

e |t looks like the handlers are not getting removed
o getEventListeners(window).keyup.length
o These keep increasing

Conclusion:

¢ | wasn't deregistering the handlers correctly
https://www.pluralsight.com/guides/event-listeners-in-react-components

#4 - 01/07/2022 05:41 AM - Luke Murphey
- Status changed from New to Closed

- % Done changed from 0 to 100
